//------------------------------------------------------------------------------
// Cannon class.
//------------------------------------------------------------------------------
#ifndef _CANNON_H_
#define _CANNON_H_

#include "Missile.h"

class Cannon : public Missile {

	SO_NODE_HEADER( Cannon ) ;

    public:

	static void 	initClass() ;

	Cannon() ;
	Cannon( float height ) ;

	SoSFFloat	maxPitchRate ;
	SoSFFloat	maxYawRate ;

	virtual MissileStatus	update( float mx, float my, float deltaTime,
					SoNode *scene ) ;
	virtual SbBool		isGuided() const ;
	virtual MissileType	getMissileType() const ;
	virtual SoNode		*getIconGraph() ;

    SoEXTENDER public :

    protected:
	virtual	~Cannon() ;

    private:
	void			buildCommon() ;
	static SoSeparator	*geometry ;
	static SoSeparator	*icon ;
} ;
#endif /* !_CANNON_H_ */
