//------------------------------------------------------------------------------
// CollisionBox class header.
//------------------------------------------------------------------------------
#ifndef _COLLISIONBOX_H_
#define _COLLISIONBOX_H_

#include <Inventor/SbLinear.h>
#include <Inventor/SbBox.h>

class CollisionBox {
    public :
	CollisionBox( const SbVec3f corner[8] ) { setPoints( corner ) ; }
	CollisionBox( const SbVec3f corner[2][2][2] ) { setPoints( corner ) ; }
	CollisionBox( const SbBox3f &box ) { setPoints( box ) ; }
	CollisionBox() ;
	~CollisionBox() {}
	SbBool checkLine( const SbVec3f &A, const SbVec3f &B, SbVec3f &v,
			 SbVec3f &n ) const ;
	SbBool checkBox( SbBox3f &box, SbVec3f &v, SbVec3f &n ) ;
	void setPoints( const SbVec3f corner[8] ) ;
	void setPoints( const SbVec3f corner[2][2][2] ) ;
	void setPoints( const SbBox3f &box ) ;
	const SbVec3f *getPoints() { return points ; }
	const SbVec3f &operator []( int i ) { return points[i] ; }
	const SbVec3f &getNormal( int i ) { return N[i] ; }
	void print( const char *label ) const ;
    private :
	SbVec3f	points[8] ;
	SbVec3f origin[3][2] ;
	SbVec3f	N[3] ;
	float	d[3][2] ;
	float	n2[3] ;
	void updateFromPoints() ;
	CollisionBox( CollisionBox & ) ;
} ;

#endif /* !_COLLISIONBOX_H_ */
