//------------------------------------------------------------------------------
// Header for DamageControl class.
//------------------------------------------------------------------------------

#ifndef	_DAMAGECONTROL_H_
#define	_DAMAGECONTROL_H_

#include <Inventor/SbBasic.h>
#include <Inventor/SbColor.h>
#include <Inventor/SoType.h>
#include "GamePackets.h"

class SoBaseColor ;
class SoTriangleStripSet ;
class SoSeparator ;
class SoNode ;

class DamageControl {

    public :
	DamageControl() ;
	~DamageControl() ;
	SoGroup	*getDamageDisplay() { return( (SoGroup *)damageDisplay ) ; }
	float	sufferDamage( float amount ) ;
	void	restoreArmor( float maxDamage ) ;
	void	repair( float amount ) ;

    private :
	void	createDamageDisplay() ;
	float	armor ;
	float	maxArmor ;
	int	damageLevel ;
	void	updateDisplay() ;

	SoSeparator		*damageDisplay ;
	SoTriangleStripSet	*armorLeft ;
	SoTriangleStripSet	*armorGone ;
	SoBaseColor		*armorColor ;
} ;

#endif	/* _DAMAGECONTROL_H_ */
