//------------------------------------------------------------------------------
// Class for managing the dashboard.
//------------------------------------------------------------------------------

#ifndef	_DASHBOARD_H_
#define	_DASHBOARD_H_

class DamageControl ;
class RadarControl ;
class SoSeparator ;
class WeaponControl ;
class Speedometer ;
class SoInput ;
class SoText3 ;

class Dashboard {

    public :
	Dashboard() ;
	~Dashboard() ;

	SoSeparator	*getRoot() { return( root ) ; }
	RadarControl	*getRadarControl() { return( radarControl ) ; }
	WeaponControl	*getWeaponControl() { return( weaponControl ) ; }
	DamageControl	*getDamageControl() { return( damageControl ) ; }
	Speedometer	*getSpeedometer() { return( speedometer ) ; }
	void		updateScoreDisplay( int score ) ;
	void		updateNumPlayers( int val ) ;
	void		updateHeading( int newHeading ) ;
	void		addMessage( char *fmt, ... ) ;

    private :
	void	initRadarControl( SoInput *in ) ;
	void	initWeaponControl( SoInput *in ) ;
	void	initDamageControl( SoInput *in ) ;
	void	initScoreDisplay( SoInput *in ) ;
	void	initNumPlayersDisplay( SoInput *in ) ;
	void	initMessageDisplay( SoInput *in ) ;
	void	initSpeedometer( SoInput *in ) ;
	void	initCompass( SoInput *in ) ;

	SoSeparator	*root ;
	RadarControl	*radarControl ;
	WeaponControl	*weaponControl ;
	DamageControl	*damageControl ;
	Speedometer	*speedometer ;
	SoText3		*scoreHolder ;
	SoText3		*numPlayersHolder ;
	SoText3		*messages ;
	SoText3		*headingHolder ;
	int		heading ;
	int		maxMessages ;
} ;

#endif	/* _DASHBOARD_H_ */
