//------------------------------------------------------------------------------
// DestructibleObstacle class header.
//------------------------------------------------------------------------------

#ifndef _DESTRUCTIBLEOBSTACLE_H_
#define _DESTRUCTIBLEOBSTACLE_H_

#include <Inventor/fields/SoSFFloat.h>
#include "StaticObstacle.h"

class CollisionAction ;
class LosAction ;
class SoSwitch ;

class DestructibleObstacle : public StaticObstacle {

	SO_NODE_HEADER( DestructibleObstacle ) ;

    public :
	static void	initClass() ;
	DestructibleObstacle() ;
	DestructibleObstacle( const char *name ) ;
	virtual SbBool	destroy( float damage ) ;
	SoSFFloat	armor ;

    SoEXTENDER public :
	virtual void	collide( CollisionAction * ) ;
	virtual void	obstruct( LosAction * ) ;

    protected :
	virtual		~DestructibleObstacle() ;
	virtual void	processGeometry() ;
	SoSwitch	*view ;
	float		totalDamage ;

    private :
	void		createIt() ;
} ;
#endif	/* !_DESTRUCTIBLEOBSTACLE_H_ */
