//------------------------------------------------------------------------------
// Header for the ExplosionControl class.
//------------------------------------------------------------------------------

#ifndef	_EXPLOSIONCONTROL_H_
#define	_EXPLOSIONCONTROL_H_

#include <Inventor/SbLinear.h>

class AnimationMaster ;
class SoAction ;
class SoCamera ;
class SoGroup ;
class SoNode ;
class SoSeparator ;
class Vehicle ;
class SfxPoint ;

class ExplosionControl {

    public :
	ExplosionControl() ;
	~ExplosionControl() ;
	void addExplosion( const SbVec3f &pos ) ;
	void addBulletExplosion( const SbVec3f &pos ) ;
	void setCamera( SoCamera *newCamera ) ;
	void setVehicle( Vehicle *v ) ;
	SoNode *getSceneGraph() { return( (SoNode *)root ) ; }

    private :
	enum { MaxBangs = 3 } ;
	SoSeparator	*root ;
	AnimationMaster	*master ;
	SoGroup		*animation ;
	SoGroup		*smallAnimation ;
	SoCamera	*camera ;
	Vehicle		*vehicle ;
	SfxPoint	*bang[MaxBangs] ;
	int		nextBang ;
	static void	setDepthMask( void *userData, SoAction *action ) ;
} ;
#endif	/* _EXPLOSIONCONTROL_H_ */
