//------------------------------------------------------------------------------
// Class header for flyer vehicle.
//------------------------------------------------------------------------------

#ifndef	_FLYER_H_
#define	_FLYER_H_

#include "Tank.h"

class SoTranslation ;
class SoText2 ;
class SoRotationXYZ ;

class Flyer : public Tank {

	SO_NODE_HEADER( Flyer ) ;

    public :
	static void	initClass() ;
	Flyer() ;
	Flyer( const char *name ) ;
	virtual SbBool	hasConView() const ;
	virtual float	move( float xInput, float yInput, float deltaTime,
				SoNode *scene ) ;
	virtual float	moveConView( float xInput, float yInput,
				float deltaTime, SoNode *scene ) ;
	virtual SbBool	handleKeyPress( KeySym ks ) ;
	virtual void	reset() ;
	virtual void	launchWeapon( Missile *weapon,
				WeaponControl::WeaponPod pod ) ;
	virtual SbBool	okayToFire( WeaponControl::WeaponPod pod ) ;
	virtual void	showHelp( SoMFString *str, int &nLines ) ;

    protected :
	void	setParams() ;
	void	createIt() ;
	virtual	~Flyer() ;
	float	thrust ;
	void	addFirstPersonGraphics() ;
	SoTranslation	*bombSite ;
	SoText2		*altText ;
	SoRotationXYZ	*rollIndicator ;
	SoText2		*pitchText ;
	SoTranslation	*pitchIndicator ;

} ;

#endif	/* _FLYER_H_ */
