//------------------------------------------------------------------------------
// GameOutput header file.
//------------------------------------------------------------------------------

#ifndef	_GAMEOUTPUT_H_
#define	_GAMEOUTPUT_H_

#include "GamePipe.h"

class GameOutput : public GamePipe {

    public :
	enum {
		MIN_TTL = 1,
		DEFAULT_TTL = 8,
		MAX_TTL = 32
		} ;

	GameOutput( const char *filename ) ;
	GameOutput( const char *serviceName, const char *groupName,
			const char *interface, int defaultPort, int loopback,
			int timeToLive = DEFAULT_TTL ) ;
	virtual ~GameOutput() { if( rep ) delete rep ; }
	virtual int send( GamePacket *packet, int size ) ;
	virtual HostAddr getMyAddress() { return( rep->getMyAddress() ) ; }

    protected :
	GameOutput() { rep = NULL ; statusOk = TRUE ; }
	SbBool	statusOk ;

    private :
	GameOutput( const GameOutput &go ) ;
	GameOutput		*rep ;
} ;


#endif	/* _GAMEOUTPUT_H_ */
