//------------------------------------------------------------------------------
// Base class for GameInput and GameOutput classes.
//------------------------------------------------------------------------------

#ifndef	_GAMEPIPE_H_
#define	_GAMEPIPE_H_

#include <sys/types.h>

typedef u_int32_t	HostAddr ;

class GamePipe {

    public :
	enum Severity {
		NUISANCE,
		FATAL,
		} ;
	typedef void GamePipeErrorHandler( Severity s ) ;

	static void setErrorHandler( GamePipeErrorHandler *func )
		{ errorHandler = func ; }

    protected :
	GamePipe() {}
	virtual ~GamePipe() {}
	void handleError( Severity s ) ;
	int	getPortFromService( const char *serviceName, int defaultPort ) ;

    private :
	static GamePipeErrorHandler	*errorHandler ;
} ;



class GamePacket {

    public :
	GamePacket( unsigned char packetType ) {
				type = packetType ;
				version = gameVersion ;
				identifier = gameIdentifier ;
				}
	int		idSize() { return( sizeof( GamePacket ) ) ; }
	HostAddr	fromAddress ;
	unsigned short	identifier ;
	unsigned char	version ;
	unsigned char	type ;
	static void	setGameId( unsigned short id, unsigned char version ) ;

    private :
	GamePacket() ;
	static unsigned short	gameIdentifier ;
	static unsigned char	gameVersion ;
} ;



typedef GamePipe::GamePipeErrorHandler	GamePipeErrorHandler ;

#endif	/* _GAMEPIPE_H_ */
