//------------------------------------------------------------------------------
// Class for Pointblank scenario data.
//------------------------------------------------------------------------------

#ifndef _GAMESCENARIO_H_
#define _GAMESCENARIO_H_

#include <stdio.h>
#include <dirent.h>
#include <Inventor/SbBasic.h>
#include <Inventor/SbString.h>
#include "GameControl.h"

class GameScenario {

    public :
	GameScenario( const char *name ) ;
	~GameScenario() ;
	static void listGames() ;
	static void setDataDir( const char *dir ) ;
	static const char *getDataDir() { return( dataDir.getString() ) ; }
	int getId() const { return( id ) ; }
	int getNumTeams() const { return( numTeams ) ; }
	GameControl::GameMode getGameMode() const { return( mode ) ; }
	const SbString &getFilename() const { return( filename ) ; }

    private :
	GameScenario() ;
	GameScenario( const GameScenario &gs ) ;
	SbBool			loadFile( const SbString &datafile,
					SbBool fatalOnError ) ;
	int			id ;
	int			numTeams ;
	GameControl::GameMode	mode ;
	SbString		filename ;
	char			*description ;
	static DIR		*listingDir ;
	static void		initListing( const char *dirName ) ;
	static const char	*nextListing() ;
	static void		endListing() ;
	static SbString		listingDirName ;
	static SbString		dataDir ;

} ;

#endif	/* !_GAMESCENARIO_H_ */
