//------------------------------------------------------------------------------
// Goal class.
//------------------------------------------------------------------------------

#include <Inventor/nodes/SoSwitch.h>
#include "Goal.h"

SO_NODE_SOURCE( Goal ) ;


//------------------------------------------------------------------------------
// Initialize the class.
//------------------------------------------------------------------------------
void
Goal::initClass()
{
	if( DestructibleObstacle::getClassTypeId() == SoType::badType() )
	{
		DestructibleObstacle::initClass() ;
	}
	SO_NODE_INIT_CLASS( Goal, DestructibleObstacle,
				"DestructibleObstacle" ) ;
}



//------------------------------------------------------------------------------
// Constructor.
//------------------------------------------------------------------------------
Goal::Goal() :
	DestructibleObstacle( "models/goal.iv" )
{
	createIt() ;
}



//------------------------------------------------------------------------------
// Alternate constructor.
//------------------------------------------------------------------------------
Goal::Goal(
	const char *name
	) :
	DestructibleObstacle( name )
{
	createIt() ;
}



//------------------------------------------------------------------------------
// Common constructor code.
//------------------------------------------------------------------------------
void
Goal::createIt()
{
	SO_NODE_CONSTRUCTOR( Goal ) ;
	SO_NODE_ADD_FIELD( onRadar, ( TRUE ) ) ;
}



//------------------------------------------------------------------------------
// Destructor.
//------------------------------------------------------------------------------
Goal::~Goal()
{
}



//------------------------------------------------------------------------------
// Restore.
//------------------------------------------------------------------------------
void
Goal::restore()
{
	view->whichChild = 0 ;
	totalDamage = 0 ;
}
