//------------------------------------------------------------------------------
// GroundMesh class header.
//------------------------------------------------------------------------------

#ifndef	_GROUNDMESH_H_
#define	_GROUNDMESH_H_

#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/fields/SoMFFloat.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/misc/SoChildList.h>
#include <Inventor/nodes/SoSubNode.h>
#include "GroundShape.h"

class SoSensor ;
class SoSeparator ;
class SoCoordinate3 ;
class SoTransform ;
class SoShapeHints ;
class SoFieldSensor ;
class FollowTerrainAction ;
class LosAction ;

class GroundMesh : public GroundShape {

	SO_NODE_HEADER( GroundMesh ) ;

    public :

	static void	initClass() ;

	GroundMesh() ;

	SoSFInt32	verticesPerRow ;
	SoSFInt32	verticesPerColumn ;
	SoSFInt32	maxSize ;

    SoEXTENDER public :

    protected:
	virtual		~GroundMesh() ;
#if defined(SO_VERSION) && SO_VERSION > 1 && SO_VERSION_REVISION > 0
	virtual SbBool	readInstance( SoInput *in, unsigned short flags ) ;
#else
	virtual SbBool	readInstance( SoInput *in ) ;
#endif
	virtual void	buildIt() ;
	virtual SbBool	checkObstruction( SbVec3f &localStart,
				SbVec3f &localEnd, SbBool findDetail ) ;
	virtual void	intersect( FollowTerrainAction *, float, float ) ;

    private :
	float	getHeight( float w, float l, SbVec3f &weight,
				int32_t &nA, int32_t &nB, int32_t &nC ) ;
	SbBool	adjustEnd( int i1, int i2, int j1, int j2, const SbVec3f &beg,
				SbVec3f &end ) ;
	SoFieldSensor	*vprChangedSensor ;
	SoFieldSensor	*vpcChangedSensor ;
	SoFieldSensor	*maxSizeChangedSensor ;
} ;
#endif /* !_GROUNDMESH_H_ */
