//------------------------------------------------------------------------------
// GroundStrip class header.
//------------------------------------------------------------------------------

#ifndef	_GROUNDSTRIP_H_
#define	_GROUNDSTRIP_H_

#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/fields/SoMFFloat.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/misc/SoChildList.h>
#include <Inventor/nodes/SoSubNode.h>
#include "GroundShape.h"

class FollowTerrainAction ;

class GroundStrip : public GroundShape {

	SO_NODE_HEADER( GroundStrip ) ;

    public :

	static void	initClass() ;

	GroundStrip() ;

    SoEXTENDER public :

    protected:
	virtual		~GroundStrip() ;
	virtual void	buildIt() ;
	virtual SbBool	checkObstruction( SbVec3f &localStart,
				SbVec3f &localEnd, SbBool findDetail ) ;
	virtual void	intersect( FollowTerrainAction *, float, float ) ;

    private :
	float		getHeight( float l, SbVec2f &weight, int32_t &nA,
				int32_t &nB ) ;
} ;
#endif /* !_GROUNDSTRIP_H_ */
