//------------------------------------------------------------------------------
// GuidedMissile class.
//------------------------------------------------------------------------------
#ifndef _GUIDEDMISSILE_H_
#define _GUIDEDMISSILE_H_

#include "Missile.h"

class GuidedMissile : public Missile {

	SO_NODE_HEADER( GuidedMissile ) ;

    public:

	static void 	initClass() ;

	GuidedMissile() ;
	GuidedMissile( float height ) ;

	SoSFFloat	maxPitchRate ;
	SoSFFloat	maxYawRate ;

	virtual MissileStatus	update( float mx, float my, float deltaTime,
					SoNode *scene ) ;
	virtual SbBool		isGuided() const ;
	virtual MissileType	getMissileType() const ;
	virtual SoNode		*getIconGraph() ;

    SoEXTENDER public :

    protected:
	virtual	~GuidedMissile() ;

    private:
	void			buildCommon() ;
	static SoSeparator	*geometry ;
	static SoSeparator	*icon ;
} ;
#endif /* !_GUIDEDMISSILE_H_ */
