//------------------------------------------------------------------------------
// InvertRotation engine class.
//------------------------------------------------------------------------------
#include "InvertRotation.h"


SO_ENGINE_SOURCE( InvertRotation ) ;



//------------------------------------------------------------------------------
// Class initialization.
//------------------------------------------------------------------------------
void
InvertRotation::initClass()
{
	SO_ENGINE_INIT_CLASS( InvertRotation, SoEngine, "Engine" ) ;
}



//------------------------------------------------------------------------------
// Constructor.
//------------------------------------------------------------------------------
InvertRotation::InvertRotation()
{
	SO_ENGINE_CONSTRUCTOR( InvertRotation ) ;

	// Inputs
	SO_ENGINE_ADD_INPUT( rotation, ( 0.0f, 0.0f, 1.0f, 0.0f ) ) ;

	// Outputs
	SO_ENGINE_ADD_OUTPUT( invRotation, SoSFRotation ) ;
}



//------------------------------------------------------------------------------
// Destructor.
//------------------------------------------------------------------------------
InvertRotation::~InvertRotation()
{
}



//------------------------------------------------------------------------------
// Input changed, so create new output.
//------------------------------------------------------------------------------
void
InvertRotation::evaluate()
{
	if( invRotation.getNumConnections() > 0 )
	{

		SO_ENGINE_OUTPUT( invRotation, SoSFRotation,
			setValue( rotation.getValue().inverse() ) );
	}
}
