//------------------------------------------------------------------------------
// Class header for mauler vehicle.
//------------------------------------------------------------------------------

#ifndef _MAULER_H_
#define _MAULER_H_

#include "Tank.h"

class SoTranslation ;
class SoText2 ;
class SoRotationXYZ ;


class Mauler : public Tank {

	SO_NODE_HEADER( Mauler ) ;

    public :
	static void	initClass() ;
	Mauler() ;
	Mauler( const char *name ) ;
	virtual SbBool	hasConView() const ;
	virtual float	moveConView( float mx, float my, float dt,
				SoNode *scene ) ;
	virtual void	launchWeapon( Missile *weapon,
				WeaponControl::WeaponPod pod ) ;
	virtual SbBool	hasRangeFinder() const { return( TRUE ) ; }
	virtual void	setRange( float d ) ;
	virtual void	showHelp( SoMFString *str, int &nLines ) ;

    protected :
	void	setParams() ;
	void	createIt() ;
	virtual	~Mauler() ;
	void	addFirstPersonGraphics() ;
	SbRotation	launchDir ;
	SoRotationXYZ	*rangeRot ;
	SoText2		*rangeText ;
	SoText2		*targetRangeText ;
} ;

#endif	/* !_MAULER_H_ */
