//------------------------------------------------------------------------------
// Radar header.
//------------------------------------------------------------------------------

#ifndef _RADAR_H_
#define _RADAR_H_

#include <Inventor/fields/SoMFColor.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFRotation.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/nodes/SoShape.h>
#include "Utilities.h"

class SoGLRenderAction ;


class Radar : public SoNode {

	SO_NODE_HEADER( Radar ) ;

    public :
	SoMFVec3f	target ;
	SoSFVec3f	center ;
	SoSFRotation	rotation ;
	SoMFColor	rgb ;

	static void	initClass() ;
	Radar() ;

    protected :
	virtual void	GLRender( SoGLRenderAction *action ) ;
	virtual ~Radar() ;
	virtual SbBool	affectsState() const { return( FALSE ) ; }

    private :
	SbVec3f	up ;
	void calculateUp()
		{ Utilities::setUpVector( rotation.getValue(), up ) ; }
} ;

#endif	/* _RADAR_H_ */
