//------------------------------------------------------------------------------
// Group node that only redraws when a global field is set or when the scene
// graph below them changes.
//------------------------------------------------------------------------------

#ifndef	_REDRAW_GROUP_
#define	_REDRAW_GROUP_

#include <Inventor/nodes/SoGroup.h>

class SoSensor ;
class SoNodeSensor ;

class RedrawGroup : public SoGroup {

	SO_NODE_HEADER( RedrawGroup ) ;

   public :
	RedrawGroup() ;
	RedrawGroup( int nChildren ) ;
	static void	initClass() ;
	static void	forceRedraw() { redrawCount = maxRedraws ; }
	static void	clearRedraw() { if( redrawCount > 0 ) redrawCount-- ; }

   SoEXTENDER public :
	virtual void	GLRender( SoGLRenderAction *action ) ;

   protected :
	static const int	maxRedraws ;
#if defined(SO_VERSION) && SO_VERSION > 1 && SO_VERSION_REVISION > 0
	virtual SbBool	readInstance( SoInput *in, unsigned short flags ) ;
#else
	virtual SbBool	readInstance( SoInput *in ) ;
#endif
	virtual ~RedrawGroup() ;

   private :
	static int	redrawCount ;
	int		redrawChildren ;
	SoNodeSensor	*sceneSensor ;
	static void	sceneChangedCB( void *data, SoSensor *sensor ) ;
	void		createIt() ;
} ;

#endif	/* _REDRAW_GROUP_ */
