//------------------------------------------------------------------------------
// RotateRotation engine class.
//------------------------------------------------------------------------------
#include "RotateRotation.h"


SO_ENGINE_SOURCE( RotateRotation ) ;



//------------------------------------------------------------------------------
// Class initialization.
//------------------------------------------------------------------------------
void
RotateRotation::initClass()
{
	SO_ENGINE_INIT_CLASS( RotateRotation, SoEngine, "Engine" ) ;
}



//------------------------------------------------------------------------------
// Constructor.
//------------------------------------------------------------------------------
RotateRotation::RotateRotation()
{
	SO_ENGINE_CONSTRUCTOR( RotateRotation ) ;

	// Inputs
	SO_ENGINE_ADD_INPUT( rotationA, ( 0.0f, 0.0f, 1.0f, 0.0f ) ) ;
	SO_ENGINE_ADD_INPUT( rotationB, ( 0.0f, 0.0f, 1.0f, 0.0f ) ) ;

	// Outputs
	SO_ENGINE_ADD_OUTPUT( rotation, SoSFRotation ) ;
}



//------------------------------------------------------------------------------
// Destructor.
//------------------------------------------------------------------------------
RotateRotation::~RotateRotation()
{
}



//------------------------------------------------------------------------------
// Input changed, so create new output.
//------------------------------------------------------------------------------
void
RotateRotation::evaluate()
{
	if( rotation.getNumConnections() > 0 )
	{

		SO_ENGINE_OUTPUT( rotation, SoSFRotation,
			setValue( rotationA.getValue()*rotationB.getValue() ) );
	}
}
