//------------------------------------------------------------------------------
// SceneryFile class.
//------------------------------------------------------------------------------
#ifndef _SCENERYFILE_H_
#define _SCENERYFILE_H_

#include <Inventor/fields/SoSFString.h>
#include <Inventor/nodes/SoGroup.h>

class SoWriteAction ;

class SceneryFile : public SoGroup {

	SO_NODE_HEADER( SceneryFile ) ;

    public:
	static void 	initClass() ;
	SceneryFile( const char *name ) ;
	const SbString &getFilename() const { return( name.getValue() ) ; }

    SoEXTENDER public :
	virtual void	write( SoWriteAction *action ) ;

    protected:
	SoSFString	name ;
	SceneryFile() ;
	virtual	~SceneryFile() ;
#if defined(SO_VERSION) && SO_VERSION > 1 && SO_VERSION_REVISION > 0
	virtual SbBool	readInstance( SoInput *in, unsigned short flags ) ;
#else
	virtual SbBool	readInstance( SoInput *in ) ;
#endif
	SbBool		readGeometry() ;

    private:
	void		createIt() ;

} ;
#endif /* !_SCENERYFILE_H_ */
