//------------------------------------------------------------------------------
// RingBuffer class.
//
// $Id: RingBuffer.h,v 1.4 1995/07/23 00:39:03 fouts Exp fouts $
//------------------------------------------------------------------------------
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//
#ifndef _RINGBUFFER_H_
#define _RINGBUFFER_H_

#include <ulocks.h>

#include "Semaphore.h"


class RingBufferInput ;
class RingBufferOutput ;

class RingBuffer {

    public :
	RingBuffer( usptr_t *arena, unsigned int elementSize,
			unsigned int maxElements = 100 ) ;
	~RingBuffer() ;
	int isEmpty() ;
	int isFull() ;
	int attach() ;
	int getFilledElements() ;
	usptr_t *getArena() { return( arena ) ; } ;
	friend class RingBufferInput ;
	friend class RingBufferOutput ;

    private :
	unsigned int	elemSize ;
	unsigned int	ringSize ;
	unsigned int	numElems ;
	unsigned int	nextRead ;
	unsigned int	nextWrite ;
	void		*buffer ;
	Semaphore	*masterSem ;
	Semaphore	*bufFullSem ;
	Semaphore	*bufEmptySem ;
	usptr_t		*arena ;
	char		*arenaName ;
} ;

#endif /* _RINGBUFFER_H_ */
