//------------------------------------------------------------------------------
// Class for interacting with semaphores.
//------------------------------------------------------------------------------
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//
#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

#include <ulocks.h>

#define	SEM_NO_ERROR	(0)
#define	SEM_WAIT_FOR_OKAY	(0)
#define	SEM_OKAY		(1)


class Semaphore {

    public :
	enum InitialValue {
			WAIT_FOR_OKAY = 0,
			OKAY = 1
			} ;
	Semaphore( usptr_t *arenaPtr, InitialValue value = WAIT_FOR_OKAY ) ;
	Semaphore( Semaphore &s ) ;
	~Semaphore() ;
	int	getStatus() { return( status ) ; }
	int	waitForOkay() ;
	int	giveOkay() ;
	int	checkForOkay() ;
	int	getCount() { return( ustestsema( semaphore ) ) ; }
	void	setDebug( int val ) { debug = val ; }

    private :
	usptr_t	*arena ;
	usema_t	*semaphore ;
	int	status ;
	int	debug ;
} ;

#endif /* _SEMAPHORE_H_ */
