//------------------------------------------------------------------------------
// SfxData -- audio routine to mix in a stream of "live" data.
//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//

#ifndef	_SFXDATA_H_
#define	_SFXDATA_H_

#include "Sfx.h"
#include "RingBuffer.h"

class SfxData : public Sfx {
    public:

	// Constructors
	SfxData( int bufSize, int numBufs, int sampsPerSec ) ;

	// Destructor
	virtual ~SfxData() ;

	// Start playing the sound.
	virtual void	play() ;	// Don't call this.
	virtual void	play( char *dataPacket ) ;
	virtual void	playWait( char *dataPacket ) ;

	// Stop playing the sound.
	virtual void	stop() ;	// Doesn't do anything.

	int getFilledElements()
		{ return( dataBuf ? dataBuf->getFilledElements() : 0 ) ; }

    protected:
	virtual int		fillQueue( int *queue ) ;
	RingBuffer		*dataBuf ;
	RingBufferInput		*dataIn ;
	RingBufferOutput	*dataOut ;
	signed char		*data ;
	int			packetSize ;
	int			writeMisses ;

    private :
	SfxData() ;
	SfxData( const SfxData &d ) ;
    } ;

#endif /* _SFXDATA_H_ */
