//------------------------------------------------------------------------------
// SfxLoop -- audio sound effects class header.
//
// Chris Fouts - January 1995.
//
// $Id: SfxLoop.h,v 1.5 1995/07/18 01:54:30 fouts Exp fouts $
//------------------------------------------------------------------------------
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//

#ifndef	_SFXLOOP_H
#define	_SFXLOOP_H

#include <audio.h>
#include <signal.h>
#include "Sfx.h"

class SfxLoop : public Sfx {
    public:

	// Constructors
	SfxLoop( const char *fileName ) ;
	SfxLoop( const SfxLoop &s ) ;

	// Destructor
	virtual ~SfxLoop() ;

	// Start playing the sound loop.
	virtual void	play() ;

	// Stop playing the sound loop immediately.
	virtual void	stop() ;

	// Stop playing the sound loop at the end of the current loop.
	void		finish() ;

	// Specify a delay (in seconds) between loop iterations.
	int		setPause( float pauseTime ) ;

    protected:
	int		stopIt ;
	long		padding ;
	virtual int	fillQueue( int * ) ;
    } ;

#endif /* _SFXLOOP_H */
