//------------------------------------------------------------------------------
// SfxPitch -- audio sound effects class header.
//
// Chris Fouts - January 1995.
//
// $Id: SfxPitch.h,v 1.3 1995/07/18 01:54:30 fouts Exp $
//------------------------------------------------------------------------------
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//

#ifndef	_SFXPITCH_H
#define	_SFXPITCH_H

#include <audio.h>
#include <signal.h>
#include "SfxLoop.h"

class SfxPitch : public SfxLoop {
    public:

	// Constructors
	SfxPitch( const char *fileName ) ;
	SfxPitch( SfxPitch *s ) ;
	SfxPitch( SfxPitch &s ) ;

	// Destructors
	virtual ~SfxPitch() ;

	// Specify the pitch ratio (1.0 = original pitch)
	void		setPitch( float pitch ) ;

	// Play the sound loop
	virtual void	play() ;

	// Play the sound once (don't loop)
	void		playOnce() ;

    protected:
	long		numerator ;	// numerator for pitch
	long		denominator ;	// denominator for pitch
	virtual int	fillQueue( int * ) ;
	int		fillQueueNonPadded( int *, int, int ) ;
	int		fillQueuePadded( int *, int, int ) ;
    } ;

#endif /* _SFXPITCH_H */
