//------------------------------------------------------------------------------
// SfxSteraoPitch -- audio sound effects class header.
//
// Chris Fouts - July 1995.
//------------------------------------------------------------------------------
//
// Copyright 1995, Silicon Graphics, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of Silicon Graphics, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//

#ifndef	_SFXSTEREOPITCH_H
#define	_SFXSTEREOPITCH_H

#include <audio.h>
#include <signal.h>
#include "SfxLoop.h"

class SfxStereoPitch : public SfxLoop {
    public:

	// Constructors
	SfxStereoPitch( const char *fileName ) ;
	SfxStereoPitch( const SfxStereoPitch &s ) ;

	// Destructors
	virtual ~SfxStereoPitch() ;

	// Specify the pitch ratio (1.0 = original pitch)
	void		setPitch( float leftPitch, float rightPitch ) ;

	// Play the sound loop
	virtual void	play() ;

	// Play the sound once (don't loop)
	void		playOnce() ;

    protected:
	long		leftNumer ;	// numerator for pitch
	long		leftDenom ;	// denominator for pitch
	long		rightNumer ;	// numerator for pitch
	long		rightDenom ;	// denominator for pitch
	long		leftSampsPlayed ;
	long		rightSampsPlayed ;
	virtual int	fillQueue( int * ) ;
	int		fillQueueNonPadded( int *, int, int ) ;
	int		fillQueuePadded( int *, int, int ) ;
    } ;

#endif /* _SFXSTEREOPITCH_H */
