//------------------------------------------------------------------------------
// Header for Speedometer class.
//------------------------------------------------------------------------------

#ifndef	_SPEEDOMETER_H_
#define	_SPEEDOMETER_H_

#include <Inventor/SbBasic.h>
#include <Inventor/SbColor.h>
#include <Inventor/SoType.h>

class SoBaseColor ;
class SoTriangleStripSet ;
class SoSeparator ;
class SoNode ;

class Speedometer {

    public :
	Speedometer() ;
	~Speedometer() ;
	SoGroup	*getDisplay() { return( (SoGroup *)display ) ; }
	void	setSpeed( float speed ) ;

    private :
	int	speedLevel ;
	float	speed ;
	SbBool	positive ;
	void	updateDisplay() ;

	SoSeparator		*display ;
	SoTriangleStripSet	*lit ;
	SoTriangleStripSet	*unlit ;
	SoBaseColor		*litColor ;
} ;

#endif	/* _SPEEDOMETER_H_ */
