//------------------------------------------------------------------------------
// Static obstacle class.
//------------------------------------------------------------------------------
#ifndef _STATICOBSTACLE_H_
#define _STATICOBSTACLE_H_

#include <Inventor/fields/SoSFString.h>
#include "CollisionBox.h"
#include "Obstacle.h"


class SoNode ;
class StaticObstacle : public Obstacle {

	SO_NODE_HEADER( StaticObstacle ) ;

    public:
	static void 	initClass() ;
	StaticObstacle() ;
	StaticObstacle( const char *name ) ;

    SoEXTENDER public :
	virtual void	collide( CollisionAction *action ) ;
	virtual void	obstruct( LosAction *action ) ;

    protected:
	CollisionBox	cBox ;
	void		calculateCorners() ;
	SbBool		highAspectRatio ;
	SbVec3f		sideNormal[3] ;
	SbVec3f		halfSize ;
	virtual void	boundIt() ;
	virtual void	disableSensors() ;
	virtual void	enableSensors() ;
	virtual void	processGeometry() ;
	virtual	~StaticObstacle() ;

    private:
	void	createIt() ;
	SoFieldSensor	*positionChangedSensor ;
	SoFieldSensor	*rotationChangedSensor ;
	static void positionChangedCB( void *data, SoSensor *sensor ) ;
	static void rotationChangedCB( void *data, SoSensor *sensor ) ;
} ;
#endif /* !_STATICOBSTACLE_H_ */
