//------------------------------------------------------------------------------
// Class header for TransformSwitch.  Changes model matrix by a rotation and
// translation before traversing its children.
//------------------------------------------------------------------------------

#ifndef	_TRANSFORMSWITCH_H_
#define	_TRANSFORMSWITCH_H_

#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFRotation.h>
#include <Inventor/nodes/SoSwitch.h>

class Action ;
class State ;

class TransformSwitch : public SoSwitch {

	SO_NODE_HEADER( TransformSwitch ) ;

    public :
	TransformSwitch() ;
	static void	initClass() ;
	SoSFVec3f	position ;
	SoSFRotation	rotation ;

    SoEXTENDER public :
	virtual void	doAction( SoAction *action ) ;
	virtual void	getBoundingBox( SoGetBoundingBoxAction *action ) ;
	virtual void	GLRender( SoGLRenderAction *action ) ;
	virtual void	pick( SoPickAction *action ) ;
	virtual void	getMatrix( SoGetMatrixAction *action ) ;
	virtual void	callback( SoCallbackAction *action ) ;

    protected :
	virtual ~TransformSwitch() ;
	void	actionGuts( SoState *state, SoAction *action ) ;
} ;

#endif	/* _TRANSFORMSWITCH_H_ */
