//------------------------------------------------------------------------------
// Header for utilities class.
//------------------------------------------------------------------------------
#ifndef	_UTILITIES_H_
#define	_UTILITIES_H_

#include <Inventor/SbBasic.h>
#include <Inventor/SbLinear.h>
#include <Inventor/SoType.h>

class SoNode ;
class SoSeparator ;
class SoInput ;

class Utilities {

    public :
	Utilities( const char *envVar ) ;
	~Utilities() {}
	void setDebugLevel( int newLevel ) { debugLevel = newLevel ; }
	int getDebugLevel() { return debugLevel ; }
	void print( int level, const char *fmt ... ) ;
	void printVec( int level, const char *s, const SbVec3f &v ) ;
	void printVec( int level, const char *s, const SbVec2f &v ) ;
	void printVal( int level, const char *s, float f ) ;
	void printVal( int level, const char *s, int32_t l ) ;
	void printRot( int level, const char *s, const SbRotation &r ) ;
	static void dumpIt( const char *fileName, SoNode *node ) ;
	static void setForwardVector( const SbRotation &r, SbVec3f &forward ) ;
	static void setRightVector( const SbRotation &r, SbVec3f &right ) ;
	static void setUpVector( const SbRotation &r, SbVec3f &up ) ;
	static SoNode *getNamedNode( const char *name, SoType type ) ;
	static SoSeparator *readAll( const char *filename, SbBool quit ) ;
	static SoInput *createInput() ;
	static void setSearchDir( const char *dir ) { searchDirectory = dir ; }
	static void buildRotation( SbRotation &r, const SbMatrix &m ) ;

    private :
	int debugLevel ;
	static SbString	searchDirectory ;
} ;

#endif /* _UTILITIES_H_ */
