//------------------------------------------------------------------------------
// Node to control the zbuffer function.
//------------------------------------------------------------------------------

#ifndef	_ZBUFFERMODE_H_
#define	_ZBUFFERMODE_H_

#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/nodes/SoSubNode.h>
#include "ZbufferModeElement.h"

class SoGLRenderAction ;
class SoCallbackAction ;
class SoAction ;

class ZbufferMode : public SoNode {

	SO_NODE_HEADER( ZbufferMode ) ;

    public :
	enum Value {
		NEVER = ZbufferModeElement::NEVER,
		LESS = ZbufferModeElement::LESS,
		EQUAL = ZbufferModeElement::EQUAL,
		LEQUAL = ZbufferModeElement::LEQUAL,
		GREATER = ZbufferModeElement::GREATER,
		NOTEQUAL = ZbufferModeElement::NOTEQUAL,
		GEQUAL = ZbufferModeElement::GEQUAL,
		ALWAYS = ZbufferModeElement::ALWAYS
		} ;

	// Fields
	SoSFEnum	value ;

	ZbufferMode() ;
	static void initClass() ;

    SoEXTENDER public :
	virtual void	doAction( SoAction *action ) ;
	virtual void	GLRender( SoGLRenderAction *action ) ;
	virtual void	callback( SoCallbackAction *action ) ;

    protected :
	virtual ~ZbufferMode() ;
} ;

#endif	/* _ZBUFFERMODE_H_ */
