//------------------------------------------------------------------------------
// Audio compressor/decompressor engine.
//------------------------------------------------------------------------------

#ifndef	_AUDIOCOMP_H_
#define	_AUDIOCOMP_H_

class AudioComp {

    public :
	enum CompType {
		GSM,
		IDVI,
		IDVI8,
		NONE,
		} ;
	AudioComp( CompType type ) ;
	float	getCompRatio() { return( ratio ) ; }
	//
	// Encodes nsamps samples of 16bit mono data in inbuf and places the
	// compressed data in outbuf.  Returns the number of bytes in outbuf.
	//
	virtual int	encode( void *inbuf, int nsamps, void *outbuf )
			{ return( engine->encode( inbuf, nsamps, outbuf ) ) ; }
	//
	// Decodes inlen bytes of GSM-encoded data in inbuf and places the
	// uncompressed 16bit mono data in outbuf.  Returns the number of
	// 16bit samples in outbuf.
	//
	virtual int	decode( void *inbuf, int inlen, void *outbuf )
			{ return( engine->decode( inbuf, inlen, outbuf ) ) ; }
	virtual int	getFrameSize() { return( engine->getFrameSize() ) ; }
	virtual ~AudioComp() ;
	virtual int	compressedBufSize( int nsamps )
			{ return( engine->compressedBufSize( nsamps ) ) ; }
	virtual int	uncompressedBufSize( int nbytes )
			{ return( engine->uncompressedBufSize( nbytes ) ) ; }
	int	isOn() { return( on ) ; }

    protected :
	AudioComp() ;
	int		on ;
	int		stateSize ;
	float		ratio ;

    private :
	AudioComp	*engine ;
} ;

#endif	/* !_AUDIOCOMP_H_ */
