//------------------------------------------------------------------------------
// GSM audio compressor/decompressor engine.
//------------------------------------------------------------------------------

#ifndef	_GSMCOMP_H_
#define	_GSMCOMP_H_

#include "AudioComp.h"
#include "gsm/gsm.h"

//
// Uses GSM compression.  Input data must be 16bit mono data.
//
class GSMComp : public AudioComp {

    public :
	GSMComp() ;
	float	getCompRatio() { return( ratio ) ; }
	//
	// Encodes nsamps samples of 16bit mono data in inbuf and places the
	// compressed data in outbuf.  Returns the number of bytes in outbuf.
	//
	virtual int	encode( void *inbuf, int nsamps, void *outbuf ) ;
	//
	// Decodes inlen bytes of GSM-encoded data in inbuf and places the
	// uncompressed 16bit mono data in outbuf.  Returns the number of
	// 16bit samples in outbuf.
	//
	virtual int	decode( void *inbuf, int inlen, void *outbuf ) ;
	virtual int	getFrameSize() ;
	virtual ~GSMComp() ;
	virtual int	compressedBufSize( int nsamps )
		    { return( (int)(nsamps*sizeof(short)/ratio)+stateSize ) ; }
	virtual int	uncompressedBufSize( int nbytes )
		    { return((int)((nbytes-stateSize)*ratio/sizeof(short))) ; }
	int	isOn() { return( on ) ; }

    private :
	struct gsm_state	*state ;
} ;

#endif	/* !_GSMCOMP_H_ */
