//------------------------------------------------------------------------------
// IDVI (8bit) audio compressor/decompressor engine.
//------------------------------------------------------------------------------

#ifndef	_IDVI8COMP_H_
#define	_IDVI8COMP_H_

#include "AudioComp.h"
#include "adpcm8.h"


//
// Uses IDVI compression.  Input data must be 8bit mono data.
//
class Idvi8Comp : public AudioComp {

    public :
	Idvi8Comp() ;
	float	getCompRatio() { return( ratio ) ; }
	//
	// Encodes nsamps samples of 8bit mono data in inbuf and places the
	// compressed data in outbuf.  Returns the number of bytes in outbuf.
	//
	virtual int	encode( void *inbuf, int nsamps, void *outbuf ) ;
	//
	// Decodes inlen bytes of Idvi-encoded data in inbuf and places the
	// uncompressed 16bit mono data in outbuf.  Returns the number of
	// 8bit samples in outbuf.
	//
	virtual int	decode( void *inbuf, int inlen, void *outbuf ) ;
	virtual int	getFrameSize() ;
	virtual ~Idvi8Comp() ;
	virtual int	compressedBufSize( int nsamps )
		    { return( (int)(nsamps*sizeof(char)/ratio)+stateSize ) ; }
	virtual int	uncompressedBufSize( int nbytes )
		    { return((int)((nbytes-stateSize)*ratio/sizeof(char))) ; }
	int	isOn() { return( on ) ; }

    private :
	struct idvistate {
		adpcm8_state	state ;
		signed char	buf[1] ;
	} ;
	adpcm8_state	next ;
} ;

#endif	/* !_IDVI8COMP_H_ */
