//------------------------------------------------------------------------------
// IDVI audio compressor/decompressor engine.
//------------------------------------------------------------------------------

#ifndef	_IDVICOMP_H_
#define	_IDVICOMP_H_

#include "AudioComp.h"
#include "adpcm.h"


//
// Uses IDVI compression.  Input data must be 16bit mono data.
//
class IdviComp : public AudioComp {

    public :
	IdviComp() ;
	float	getCompRatio() { return( ratio ) ; }
	//
	// Encodes nsamps samples of 16bit mono data in inbuf and places the
	// compressed data in outbuf.  Returns the number of bytes in outbuf.
	//
	virtual int	encode( void *inbuf, int nsamps, void *outbuf ) ;
	//
	// Decodes inlen bytes of Idvi-encoded data in inbuf and places the
	// uncompressed 16bit mono data in outbuf.  Returns the number of
	// 16bit samples in outbuf.
	//
	virtual int	decode( void *inbuf, int inlen, void *outbuf ) ;
	virtual int	getFrameSize() ;
	virtual ~IdviComp() ;
	virtual int	compressedBufSize( int nsamps )
		    { return( (int)(nsamps*sizeof(short)/ratio)+stateSize ) ; }
	virtual int	uncompressedBufSize( int nbytes )
		    { return((int)((nbytes-stateSize)*ratio/sizeof(short))) ; }
	int	isOn() { return( on ) ; }

    private :
	struct idvistate {
		adpcm_state	state ;
		char		buf[1] ;
	} ;
	adpcm_state	next ;
} ;

#endif	/* !_IDVICOMP_H_ */
